Imports VaultClientOperationsLib
Imports VaultLib
Module Module1

    Sub Main()
        Dim hostname As String, username As String, password As String, repository As String

        hostname = "localhost:8085"
        username = "admin"
        password = "admin"
        repository = "Test Repository"

        If hostname.StartsWith("http://") = False Then
            hostname = "http://" + hostname
        End If
        If hostname.EndsWith("/VaultService") = False Then
            hostname += "/VaultService"
        End If
        Dim myClient As ClientInstance = New ClientInstance
        myClient.Init(VaultClientNetLib.VaultConnection.AccessLevelType.Client)
        myClient.Login(hostname, username, password)
        FindRepository(myClient, repository)

        'In theory, this would be the part where we actually do something.

        myClient.Logout()
    End Sub

    Sub FindRepository(ByVal client As ClientInstance, ByVal repositoryName As String)
        Dim reps() As VaultRepositoryInfo = Nothing
        'List all the repositories on the server.
        client.ListRepositories(reps)

        'Search for the one that we want.
        Dim r As VaultRepositoryInfo
        For Each r In reps
            If String.Compare(r.RepName, repositoryName, True) = 0 Then
                'This will load up the client side cache files and refresh the repository structure.
                'See http://support.sourcegear.com/viewtopic.php?t=6 for more on client side cache files.
                client.SetActiveRepositoryID(r.RepID, client.Connection.Username, r.UniqueRepID, True, True)
                Exit For
            End If
        Next
        If client.ActiveRepositoryID = -1 Then
0:
        End If
    End Sub

End Module
